/*********************************************************************
* 
* PROJECT:        ntproc
* FILE:           ntproc.c
* 
* DESCRIPTION:    this DLL exports some functions for process
*				  handling on windows NT
* 
* REVISION:       Started: 09/26/1998
* 
* Copyright(C) 1998, Tomas Restrepo. All rights Reserved
*
* This source code, as well as it's executable is freely 
* distributable, PROVIDED this copyright is NOT removed or
* altered. In other words, don't take credit for my work.
* 
* No warrantee of any kind, express or implied, is included with this
* software; use at your own risk, responsibility for damages (if any)
* to anyone resulting from the use of this software rests entirely 
* with the user.
*
* Feel free to send bugs, suggestions, flames, etc. to:
* winder@bigfoot.com
* 
*********************************************************************/


#define WINDAPI _declspec(dllexport)

#include <windows.h>				// windows headers
#include "ntdll.h"					// some definitions

//////////////////////////////////////////////////////////////////////
// Entry point

/*--
* DllMain()
*
* Entry Point for the dll.
--*/
BOOL WINAPI DllMain (HINSTANCE hInstDll, DWORD dwReason, LPVOID lpvReserved)
{
	switch (dwReason)
	{
	case DLL_PROCESS_ATTACH:
		// dll attached to a new process
		break;

	case DLL_THREAD_ATTACH:
		// new thread created in current process
		break;

	case DLL_THREAD_DETACH:
		// a thread in the current process terminated
		break;

	case DLL_PROCESS_DETACH:
		// calling process is exiting
		break;
	}
	return TRUE;
} // DllMain()


//////////////////////////////////////////////////////////////////////
// Exportable functions

/*--
* GetProcessHandleCount()
*
* Returns the number of opened handles for the given process handle
* Returns -1 if an error ocurred.
--*/
DWORD WINDAPI GetProcessHandleCount (HANDLE hProcess)
{
	DWORD	dwHandleCount = 0;
	ULONG	dwSize;
	if (NtQueryInformationProcess ((HANDLE)-1, ProcessHandleCount, 
		(PVOID)&dwHandleCount, sizeof (dwHandleCount), &dwSize) == STATUS_SUCCESS)
	{
		return dwHandleCount;
	}
	else
		return (-1);
} // GetProcessHandleCount()


/*--
* GetProcessInformation()
*
* gets basic information for a given process
--*/
